#include <iostream.h>

void Sort(double a[], int size)

// Sort a[0], ..., a[size-1] in ascending order.

{
    int i, iMax;
    double aTemp;

    for (int n = size;   n >= 2;   n--) {

        // Find the index "iMax" of the largest element
        //   among a[0], ..., a[n-1]:

        for (iMax = 0, i = 1;   i < n;   i++)
            if (a[i] > a[iMax]) iMax = i;

        // Swap a[iMax] with a[n-1]:

        aTemp = a[iMax];    // Save a[iMax] in a temporary location.
        a[iMax] = a[n-1];   // Copy a[n-1] to a[iMax].
        a[n-1] = aTemp;     // Copy saved value to a[n-1].

        // Decrement n (accomplished by n-- in the "for" loop).
    }
}

//****************************************************************

int Search(int a[], int size, int target)

// Performs binary search on the array
//   a[0] < a[1] < ... < a[size-1].
//   Looks for an element a[k] equal to "target".
// Returns k if the target is found; -1 otherwise.

{
    int left = 0, right = size-1, middle;
    int k = -1;

    while (left <= right) {

        // Take the index of the middle element between
        //   "left" and "right":

        middle = (left + right) / 2;

        // Compare  this element to the "target" value
        //  and adjust the search range accordingly:

        if (target > a[middle])
            left = middle + 1;
        else if (target < a[middle])
            right = middle - 1;
        else {     // target must be equal to a[middle]
            k = middle;
            break;
        }
    }

    return k;
}

//****************************************************************

int GCF(int m, int n)

// Returns the greatest common factor of two positive integers
//   m and n.

{
    int r;

    for(;;) {  // Repeat (until break)
        r = m % n;         // r = "m modulo n" i.e. the remainder
                           //    when m is divided by n.
        if (r == 0)        // i.e. if n evenly divides m
             break;
        m = n;             // Substitute values: m becomes n and 
        n = r;             //   n becomes r.  GCF(m,n) = GCF(n,r).
    }
    return n;
}

//****************************************************************

void main()

{
    double x[6] = {1.1, 3.3, 5.5, 6.6, 4.4, 2.2};
    int a[6] = {8, 13, 21, 34, 55, 89}, target = 34;
    int m = 1001, n= 4235;

    Sort(x, 6);
    cout << "Sorted: " << x[0] << ' ' << x[1] << ' ' << x[2] << ' ' << x[3]
                               << ' ' << x[4] << ' ' << x[5] << endl;
    cout << "Search: position of " << target << " = "
                   << Search(a, 6, target) << endl;
    cout << "GCF(" << m << ',' << n << ") = " << GCF(m,n) << endl;
}
