// GRADES.CPP
//
// This program reads students' grades from a file, GRADES.DAT,
//   and finds the average, the highest and the lowest grade.
//
// Author: Mark Avgerinos
// Date 05-21-1999
//

#include <fstream.h>  // Includes <iostream.h>, but also supports
                      //   file I/O.
#include <iomanip.h>

const int MAXSTUDENTS = 100;

//****************************************************************
//******************    Function Prototypes    *******************
//****************************************************************

int ReadNumbers (char filename[], int a[]);
int AddElements (int a[], int size);
int MaxElement (int a[], int size);
int MinElement (int a[], int size);

//****************************************************************
//******************            Main           *******************
//****************************************************************

void main()

{
    int nStudents;
    int grades[MAXSTUDENTS];
    double avgGrade;

    nStudents = ReadNumbers("GRADES.DAT", grades);
    if (!nStudents) {
        cout << "Cannot open GRADES.DAT or the file is empty.\n";
        return;
    }

    cout << nStudents << " students\n";

    avgGrade = (double)AddElements(grades, nStudents) / nStudents;
    cout << "The average grade is "
         << setprecision(1) << avgGrade << endl;
    cout << "The highest grade is "
         << MaxElement(grades, nStudents) << endl;
    cout << "The lowest grade is "
         << MinElement(grades, nStudents) << endl;
}

//****************************************************************
//******************          Functions        *******************
//****************************************************************

int ReadNumbers (char filename[], int a[])

// Reads integers from a file "filename" into the array a.
// Returns the number of elements read, or 0, if the file
//   does not exist or is empty.

{
    int n = 0;

    // Declare a variable "inp" of the data type "ifstream"
    //   -- input file stream -- and open the file with the
    //   requested name "filename" for reading:

    ifstream inp(filename);

    // Checks that the file exists:

    if (!inp)  
        return 0;

    // "Extract numbers from the file input stream"
    //    (i.e. read numbers from the file into the array)
    //    until the end of file, or array is full:

    while (n < MAXSTUDENTS && inp >> a[n])
        n++;

    // Returns the number of elements read:

    return n;
}

//****************************************************************

int AddElements (int a[], int size)

// Returns a[0] + a[1] + ... + a[size-1]

{
    ...
}

//****************************************************************

int MaxElement (int a[], int size)

// Returns the value of the largest element of the array a.
// "size" is the number of elements.

{
    ...
}

//****************************************************************

int MinElement (int a[], int size)

// Returns the value of the smallest element of the array a.
// "size" is the number of elements.

{
    ...
}

