// GREP.CPP
//
// This program reads a file and prints out all lines
//   where a given word occurs.
//
//  Usage:
//     C> grep word filename 
//
//  Author: Yu Nix
//  Date: 01/12/70

#include <fstream.h>
#include <iomanip.h>
#include <ctype.h>
#include "astring.h"

bool Found(astring &word, astring &str);

void main(int argc, char *argv[])

{
    astring word, filename;
    astring line;
    int lineNum = 0;

    // Get the arguments from the command line:

    if (argc < 3) {         // Must have at least 3 words
                            //   on the command line.
        cout << "Usage:\n\tC> grep word filename\n";
        return;
    }

    word = argv[1];      // argv[1] is the word to search for.
    filename = argv[2];  // argv[2] points to the file name

    ...
    ...
}

//****************************************************************

bool Found(astring &word, astring &str)

// Looks for "word" in "str". Assumes word has only alphanumeric
//   characters and matches them to characters in str.
// Returns true if a substring equal to "word" is found,
//   false otherwise.

{
    ...
    ...
}
