// NOTABS.CPP
// 
// This program prompts the user for the input file name,
//   reads the file, converts each tab into spaces, and writes the
//   result in the output file.
//
// Author: Tabitha Spacek
// Rev 2.0

#include <fstream.h>

const int tabstop = 4;
const unsigned BUFSIZE = 20000;

// Function prototypes:

char *ReadText(char filename[], int &length);
char *TabsToSpaces (char buf[], int n, int &length);
void WriteText(char filename[], char buf[], int length);

//****************************************************************
//***************                main          *******************
//****************************************************************

void main()

{
    char filename[40];
    int length, length1;
    char *buf, *buf1;

    // Read the text from an input file
    cout << "Input file name: ";
    cin >> filename;
    buf = ReadText(filename, length);
    if (!buf) return;

    // Replace tabs with spaces:
    buf1 = TabsToSpaces(buf, length, length1);
    if (!buf1) {
        delete [] buf;
        return;
    }

    // Save the result in the output file:   
    cout << "Output file name: ";
    cin >> filename;
    WriteText(filename, buf1, length1);

    // Clean up:
    delete [] buf1;
    delete [] buf;
}

//****************************************************************
//***************            Functions         *******************
//****************************************************************

char *ReadText(char filename[], int &length)

// Allocates a char array, reads text from the file "filename"
//   into that array.  Sets "length" to the number of characters
//   read.
// Returns a pointer to the new array.

{
    char *buf;

    // Open the input file
    ...

    // Allocate a character buffer:
    ...

    // Read the input file into buf:
    ...

    return buf;
}

//****************************************************************

char *TabsToSpaces (char buf[], int n, int &length)

// Allocates a char array and copies text from buf[] to the new
//   array, replacing each tab with spaces.  Sets "length"
//   to the number of characters in the new array.
//   n is the number of chars in the original array.
// Returns a pointer to the modified text.

{
    char *buf1;       // Pointer to the modified text buffer.

    ...
    return buf1; 
}

//****************************************************************

void WriteText(char filename[], char buf[], int length)

// Creates a new file, "filename", and writes characters from
//   "buf" into the file. "length" indicates the
//   number of characters to be written.


{
    ...
}

