//
// Standard library string functions re-implemented.
//

#include <iostream.h> 
 
unsigned strlen(const char *s)

// Returns the length of a null-terminated string.

{
    unsigned count = 0;

    while (*s) {
        s++;            // Increment pointer.
        count++;        // Increment count.
    }
    return count;
}

//****************************************************************

char *strchr(const char *s, int c)

// Returns the pointer to the first occurrence of c
//   in the string s (or null if not found).

{
    while (*s && *s != c) s++;
    if (*s != c) s = 0;
    return (char *)s;     // a cast from "const char*" to "char*"
}

//****************************************************************

char *strcat(char *s1, const char *s2)

// Appends string s2 to s1.
// Returns s1.

{
    char *s = s1;
    while (*s) s++;             // Skip the first string.
    while (*s2) *s++ = *s2++;   // Copy the second string.
    *s = '\0';                  // Append the terminating null.

    return s1;
}
 
//****************************************************************
 
void main() 
 
{ 
    char text[14] = "Hello"; 
 
    cout << '[' << text << ']' << " Length = " << strlen(text) << endl; 
    strcat(text, ", World!"); 
    cout << '[' << text << ']' << " Length = " << strlen(text) << endl; 

    char *d = strchr(text, 'W'); 
    cout << '[' << d << ']' << " Length = " << strlen(d) << endl; 
    char *t = strchr(text, '\0'); 
    cout << '[' << t << ']' << " Length = " << strlen(t) << endl; 
}
