// ASTACK.CPP
//
// Array implementation of stack.
//

#include "astack.h"

STATUS Create(STACK &stack, int size)

// Allocates a stack buffer of the specified size
//   and initializes the stack.

{
    stack.buf = new int[size];
    if (!stack.buf)
        return FAILED;
    stack.size = size;
    stack.sp = 0;
    return OK;
}

//****************************************************************

STATUS Push(STACK &stack, int item)

// Returns OK if "item" is successfully pushed on stack,
//   FAILED if the stack was full.

{
    if (stack.sp == stack.size)
        return FAILED;
    stack.buf[stack.sp++] = item;
    return OK;
}

//****************************************************************

STATUS Pop(STACK &stack, int &item)

// Returns OK if "item" is successfully popped from stack,
//   FAILED if the stack was empty.

{
    if (stack.sp == 0)
        return FAILED;
    item = stack.buf[--stack.sp];
    return OK;
}

//****************************************************************

void Destroy(STACK &stack)

// Frees the stack buffer.

{
    delete [] stack.buf;
}

