// ASTACK.H
//
// Array implementation of stack.
//

#ifndef _STACK_H_
#define _STACK_H_
#include "bool.h"

struct STACK {
    int size;
    int *buf;
    int sp;
};

enum STATUS {FAILED, OK};

// Function prototypes:

STATUS Create(STACK &stack, int size);
STATUS Push(STACK &stack, int item);
STATUS Pop(STACK &stack, int &item);
void Destroy(STACK &stack);

// Inline functions:

inline bool IsEmpty(STACK &stack) {
    return (stack.sp == 0);
}

inline bool IsFull(STACK &stack) {
    return (stack.sp == stack.size);
}

inline int NoElements(STACK &stack) {
   return stack.sp;
}

#endif  // _STACK_H_

