// COMPLEX.H

#ifndef _COMPLEX_H_
#define _COMPLEX_H_

#include <iostream.h>

class COMPLEX {    // Represents a complex number a + bi

  private:

    float a;     // Real part.
    float b;     // Imaginary part.

  public:

    COMPLEX(float x = 0., float y = 0.); // Constructor
    float Re() {return a;}               // Returns the real part.
    float Im() {return b;}               // Returns the imaginary part.
    COMPLEX operator+ (COMPLEX &z);      // Returns this number + z;
    COMPLEX operator* (COMPLEX &z);      // Returns this number * z;
//    ...

    // Overloaded << operator for use with cout:
    friend ostream& operator<< (ostream& str, COMPLEX &z);
//    ...
};

inline ostream& operator<< (ostream& str, COMPLEX &z)

{
    str << '(' << z.a << ',' << z.b << ')';
    return str;
}

#endif  //  _COMPLEX_H_

////////////////////////////////////////////////////////////////
// COMPLEX.CPP

//#include "complex.h"

COMPLEX::COMPLEX(float x, float y)

// Constructor: x is the real part and y is the imaginary part.

{
    a = x;
    b = y;
}

COMPLEX COMPLEX::operator+ (COMPLEX &z)

// Returns a complex number equal to the sum of this number and
//  the argument.

{
    float x = a + z.a;
    float y = b + z.b;
    return COMPLEX(x,y);
}

COMPLEX COMPLEX::operator* (COMPLEX &z)

// Returns a complex number equal to the product of this number and
//  the argument.

{
    float x = a*z.a - b*z.b;
    float y = a*z.b + b *z.a;
    return COMPLEX(x,y);
}

//...

////////////////////////////////////////////////////////////////
// TEST.CPP

//#include "complex.h"

void main()

{
    COMPLEX z1(1.,1.), z2(1.,-1.), sum, product;
    sum = z1 + z2;
    product = z1 * z2;
    cout << "sum = " << sum << " product = " << product << endl;
}

