// EMAIL.CPP
//
//   Author: ...
//   This program simulates a toy e-mail system.

#include <iostream.h>
#include <ctype.h>
#include <string.h>
#include "queue.h"

struct MESSAGE {
    char from[20];
    char to[20];
    char subject[40];
    char text[80];
};

struct SUBSCRIBER {
    char name[20];
    QUEUE<MESSAGE> mailbox;   // Say: "QUEUE of MESSAGE(s) mailbox."
};

// Array of subscribers

static const int MAXNUM = 20;
static SUBSCRIBER subscriber[MAXNUM];
static int nUsers = 0;    // Current number of users.

//****************************************************************

static SUBSCRIBER *FindUser(char name[])

// Returns pointer to the user whose name matches (case-blind)
//   "name", or 0, if not found.

{
    int n;

    for (n = 0;   n < nUsers;   n++) {
        ...
        ...
    }
    if (n >= nUsers) return 0;

    return &subscriber[n];
}

//****************************************************************

static SUBSCRIBER *NewUser(char name[])

// Adds a new user to the array of subscribers.
// Returns pointer to the new subscriber, or 0 if failed.

{
    ...
    ...
}

//****************************************************************

static SUBSCRIBER *Login()

// Prompts for the user name; finds it in the subscriber array or
//   adds a new user with the given name, if not found.
// Returns pointer to the logged-in user,
//   or 0, if Q was entered.

{
    char name[20];
    SUBSCRIBER *user;

    cout << "Username (or 'Q' to quit): ";
    cin.getline(name, 20);
    if (stricmp (name, "Q") == 0) return 0;
    
    user = FindUser(name);
    if (!user) user = NewUser(name);

    return user;
}

//****************************************************************

static void ProcessCommands(SUBSCRIBER *user)

{
    char key = ' ';
    char name[20];
    MESSAGE msg;
    SUBSCRIBER *dest;

    while (key != 'Q') {

        // Show menu, get next command:

        cout << "     (R)ead next message\n";
        cout << "     (S)end message\n";        
        cout << "     (Q)uit\n";
        cout << "\n";
        cout << "Next command ==> ";
        cin >> key;
        cin.ignore(256, '\n');
        key = toupper(key);

        // Execute command:

        switch (key) {

          case 'R':    // Read next message

            ...
            ...

          case 'S':    // Send message

            ...
            ...

          case 'Q':        // Quit
          default:
            break;
        }
    }
}

//****************************************************************

void main()

{
    SUBSCRIBER *user;

    while ((user = Login()) != 0) {
        cout << "\nWelcome " << user->name << "\n\n";
        ProcessCommands(user);
    }
}

