// LLQUEUE.CPP
//
// Queue implemented with linked list.

#include "llqueue.h"

STATUS LLQUEUE::Insert (ORDER &info)

// Inserts a new element at the rear of the queue.
// Returns OK if successful, FAILED if out of memory.

{
    // Allocate a new node and set its values:
    NODE *newnode = new NODE;
    if (!newnode) return FAILED;
    newnode->info = info;
    newnode->next = 0;

    // Append the new node at the rear of the queue:
    if (rear == 0)
        front = rear = newnode;
    else {
        rear->next = newnode;
        rear = newnode;
    }
    return OK;
}

//****************************************************************

STATUS LLQUEUE::Remove (ORDER &info)

// Retrieves and removes the first element from the queue.
// Returns OK if successful, FAILED if the queue is empty.

{
    // Retrieve the first element from the queue:
    if (front == 0) return FAILED;
    info = front->info;

    // Remove the node from the front of the queue
    NODE *next = front->next;
    delete front;
    front = next;
    if (front == 0) // If removed the last element...
        rear = 0;
    return OK;
}

//****************************************************************

LLQUEUE::~LLQUEUE ()

// Destructor: deletes all elements remaining in the queue.

{
    NODE *next;

    while (front) {
        next = front->next;
        delete front;
        front = next;
    }
}

