// LLQUEUE.H
//
// Queue implemented as a linked list.

#ifndef _LLQUEUE_H_
#define _LLQUEUE_H_

#include "bool.h"    // defines bool type
#include "status.h"  // defines STATUS type

struct ORDER {
    char address[256];
    char items[256];
    // ... other elements
};

struct NODE {
    ORDER info;
    NODE *next;
};

class LLQUEUE {

  private:

    NODE *front;
    NODE *rear;

  public:

    LLQUEUE() {front = rear = 0;}
    ~LLQUEUE();
    STATUS Insert (ORDER &info);
    STATUS Remove (ORDER &info);
    bool IsEmpty() {return (front == 0);}
};

#endif    // _LLQUEUE_H_    

