// MORSE.H

#ifndef _MORSE_H_
#define _MORSE_H_

struct MORSECODE {
    char symbol;               // e.g. 'A'
    char code[10];             // e.g. ".-"
};

struct TNODE {
    char symbol;
    TNODE *left;
    TNODE *right;

    TNODE() {                   // Constructor
        symbol = '*';
        left =
        right = 0;
    }
};

class TELEGRAPH {

  private:

    static MORSECODE table[40];
    static TNODE *root;

    static void DestroyTree(TNODE *node);

  public:

    static void Open();
    static void Close();

    void Encode(char text[], char morse[]);
    void Decode(char morse[], char text[]);
};

#endif _MORSE_H_

