// PIZZA.CPP
//
// Pizza Plus Co. Home Deliveries
// Author: Roman Crust
// Rev 1.1


#include <iostream.h>
#include <ctype.h>
#include "llqueue.h"
#include "rbqueue.h"

void main()

{
    char key = ' ';
    STATUS status = OK;
    ORDER order;
    char driverName[20];

    LLQUEUE pendingOrders;
    RBQUEUE availDrivers;

    cout << "\n*** Pizza Plus Co. Home Deliveries ***\n\n";

    while (key != 'Q' && status == OK) {

        // Show menu, get next command:

        cout << "     (N)ew order\n";
        cout << "     (D)river available\n";        
        cout << "     (Q)uit\n";
        cout << "\n";
        cout << "Next command ==> ";
        cin >> key;
        cin.ignore(256, '\n');
        key = toupper(key);

        // Execute command:

        switch (key) {

          case 'N':    // Enter new order

            cout << "   Address ==> ";
            cin.getline(order.address, 256);
            cout << "   Ordered Items ==> ";
            cin.getline(order.items, 256);
            cout << "\n";

            status = pendingOrders.Insert(order);
            if (status == OK)
                cout << "<OK>\n";
            else
                cout << "*** Orders queue overflow *** \n";
            break;
            
          case 'D':    // Enter the name of available driver

            cout << "   Driver Name ==> ";
            cin.getline(driverName, 20);
            cout << "\n";

            status = availDrivers.Insert(driverName);
            if (status == OK)
                cout << "<OK>\n";
            else
                cout << "*** Driver names buffer overflow *** \n";
            break;

          case 'Q':
          default:

            break;
        }

        // Dispatch available drivers to deliver pending orders 

        if (status == OK && !availDrivers.IsEmpty() &&
                            !pendingOrders.IsEmpty()) {
            pendingOrders.Remove(order);
            availDrivers.Remove(driverName);
            cout << "\n\n*** Attention: " << driverName << "\n"
                 << "*\n" 
                 << "*      " << order.items << "\n"
                 << "*  to:\n"
                 << "*      " << order.address << "\n"
                 << "*******************\n\n";
        }
    }
}

