// QUEUE.H
//
// Linked list implementation of the queue ADT as
//   a templated class.

#ifndef _QUEUE_H_
#define _QUEUE_H_

#include "bool.h"
#include "status.h"

template <class RECORD>
struct NODE {
    RECORD data;
    NODE *next;
};

template <class RECORD>
class QUEUE {        // Queue implementation with linked list

  private:

    NODE<RECORD> *front;
    NODE<RECORD> *rear;

  public:

    QUEUE() {front = rear = 0;}
    ~QUEUE();
    STATUS Insert (RECORD &data);
    STATUS Remove (RECORD &data);
    bool IsEmpty() {return (front == 0);}
};

template <class RECORD>
STATUS QUEUE<RECORD>::Insert (RECORD &data)

{
    NODE<RECORD> *newnode = new NODE<RECORD>;
    if (!newnode) return FAILED;
    ...
    ...
}

//****************************************************************

template <class RECORD>
STATUS QUEUE<RECORD>::Remove (RECORD &data)

{
    if (front == 0) return FAILED;
    data = front->data;
    NODE<RECORD> *newfront = front->next;
    ...
    ...
}

//****************************************************************

template <class RECORD>
QUEUE<RECORD>::~QUEUE ()

// Destructor -- deletes all nodes from the queue

{
    NODE<RECORD> *next;
    ...
    ...
}

#endif    // _QUEUE_H_    

