// STACK.CPP
//
// Stack ADT implemented as a class.
// Member functions.
//

#include "stack.h"

STACK::STACK(int a_size)

// Constructor: creates a stack of the specified size.

{
    buf = new int[a_size];
    if (!buf)
        size = 0;
    else
        size = a_size;
    sp = 0;
}

//****************************************************************

STATUS STACK::Push(int item)

{
    if (sp == size) return FAILED;
    buf[sp++] = item;
    return OK;
}

//****************************************************************

STATUS STACK::Pop(int &item)

{
    if (sp == 0) return FAILED;
    item = buf[--sp];
    return OK;
}

//****************************************************************

STACK::~STACK()

// Destructor: frees buf.

{
    delete [] buf;
}

