// STACK.H
//
// Stack ADT implemented as a class.
// Class definition.
//

#ifndef _STACK_H_
#define _STACK_H_
#include "bool.h"

enum STATUS {FAILED, OK};

class STACK {

  private:

    int size;
    int *buf;
    int sp;

  public:

    STACK(int a_size = 1000);
    STATUS Push(int item);
    STATUS Pop(int &item);
    bool IsEmpty() {return (sp == 0);}
    bool IsFull() {return (sp == size);}
    int NoElements() {return sp;}
    ~STACK();
};

#endif   // _STACK_H_

