// VECTOR.H

template <class SOMETYPE, int SIZE>
class VECTOR {

  private:

    SOMETYPE buf[SIZE];

  public:

    VECTOR ();             // Constructor: zeroes out the array
    VECTOR (SOMETYPE a[]); // Constructor: copies array a to buf
//    ...
    int Find (SOMETYPE x); // Counts occurrences of x in buf
};

//***************************************************************
//                     MEMBER FUNCTIONS                         *
//***************************************************************

template <class SOMETYPE, int SIZE>
VECTOR<SOMETYPE,SIZE>::VECTOR()

// Constructor: zeroes out the array

{
    for (int i = 0;   i < SIZE;   i++)
        buf[i] = 0;
}

//***************************************************************

template <class SOMETYPE, int SIZE>
VECTOR<SOMETYPE,SIZE>::VECTOR (SOMETYPE a[])

// Constructor: copies array a into buf

{
    for (int i = 0;   i < SIZE;   i++)
        buf[i] = a[i];
}

//****************************************************************

template <class SOMETYPE, int SIZE>
int VECTOR<SOMETYPE,SIZE>::Find (SOMETYPE x)

// Counts occurrences of x in vector

{
    int count = 0;

    for (int i = 0;   i < SIZE;   i++)
        if (buf[i] == x) count++;
    return count;
}

////////////////////////////////////////////////////////////////
// TEST.CPP

#include <iostream.h>
//#include "vector.h"

static int  wedge[7] = {1, 2, 3, 4, 3, 2, 1};
static char hello[] = "HELLO";

void main()

{
    VECTOR<int, 7>  iVector(wedge); // Vector of 7 ints.
    VECTOR<char, 5> cVector(hello); // Vector of 5 chars.

    for (int x = 1;   x <= 4;   x++)
        cout << x << " occurs " << iVector.Find(x)
             << " times in wedge.\n";

    for (char c = 'A';   c <= 'H';   c++)
        cout << c << " occurs " << cVector.Find(c)
             << " times in HELLO\n";
}

