#include <stdlib.h>
#include "str_cls.h"

void main()

{
    cout << "\n*** Use constructors: ***\n\n";

    STRING
        str1,                // Default constructor.
        str2(3),             // Constructor: length = 3, fill = ' '.
        str3(5, '*'),        // Constructor: length = 5, fill = '*'.
        str4 = "String",     // Initialization from a literal string
        str5 = " code",      //   (or any const char *).
        str6 = str5,         // Copy constructor.
        str7 = str4 + str6;  // Initialization from expressions.

    cout << "str1 = {" << str1 << "} length = "
         << str1.Length() << endl;
    cout << "str2 = {" << str2 << "} length = "
         << str2.Length() << endl;
    cout << "str3 = {" << str3 << "} length = "
         << str3.Length() << endl;

    cout << "\n*** Use assignments: ***\n\n";
    STRING str;    
    str = str7;
    cout << "{" << str << "}\n";
    str = "String code";
    cout << "{" << str << "}\n";

    cout << "\n*** Use Find(...), Substring(...): ***\n\n";
    cout << "Position of i = " << str.Find('i')
         << " Position of ring = " << str.Find("ring")
         << " Substring = {" << str.Substring(2, 4) << "}\n";

    cout << "\n*** Use += (concatenation) operators: ***\n\n";
    str += "r!"; 
    str += '?'; 
    cout << "{" << str << "}\n";

    cout << "\n*** Use subscript operator []: ***\n\n";
    char temp = str[3]; str[3] = str[8]; str[8] = temp;
    cout << "{" << str << "}\n";

    cout << "\n*** Use relational operators: ***\n\n";
    str = "String code";
    if (str == str4 + str5)
        cout << str << " == " << str4 + str5 << endl;

    cout << "\n*** Use automatic cast to const char *: ***\n\n";
    str = "99";
    cout << "99 + 1 = " << atoi(str) + 1 << endl; 

    cout << "\n*** Use << and >> operators and getline(...): ***\n\n";
    cout << "Enter a word ==> ";
    cin >> str;
    cin.ignore(80, '\n');  // Skip to the end of line.
    cout << "word = {" << str << "}\n";
    cout << "Enter a line of chars ==> ";
    int length = str.ReadLine(cin);
    cout << "line = {" << str << "} length = " << length << endl;
}
